from bzv.inbox import Inbox
from bzv.server import main
from meresco.components import readConfig
from meresco.components.http import ObservableHttpServer
from meresco.framework import be
from sys import stdout
from weightless import Reactor

from sys import argv
args = argv[1:]
if len(args) == 1:
	configFile = args[0]
	config = readConfig(configFile)

host = config['host']
portNumber = int(config['portNumber'])
sruUpdatePortNumber = int(config['sruUpdatePortNumber'])
databasePath = config['databasePath']
if portNumber < 1024 and not isRootUser():
	print 'Need root privileges.'
	exit(123)

print 'Firing up Tilburg Beter Zoeken & Vinden Server.'
reactor = Reactor()
observableHttpServer = ObservableHttpServer(reactor, portNumber)
observableHttpServer.startServer()
if portNumber < 1024:
	runAs(config['username'], config['groupname'])

sruUpdateServer = ObservableHttpServer(reactor, sruUpdatePortNumber, prio=9)

inbox = Inbox(reactor=reactor, inboxDirectory=config['inboxDirectory'],doneDirectory=config['doneDirectory'])

server = be(main(reactor, observableHttpServer, sruUpdateServer, inbox, host, portNumber, databasePath, config))
server.once.observer_init()

inbox.processInboxDirectory()

print "Ready to rumble on", host, "at ports", portNumber, sruUpdatePortNumber
print "   - database:", databasePath, "\n"
stdout.flush()
reactor.loop()
